Module | ActiveRecord::ConnectionAdapters::SchemaStatements
In: | lib/active_record/connection_adapters/abstract/schema_statements.rb

### Methods

add_column add_index add_order_by_for_association_limiting! add_timestamps assume_migrated_upto_version change_column change_column_default change_table columns create_table distinct drop_table initialize_schema_migrations_table native_database_types options_include_default? remove_column remove_columns remove_index remove_timestamps rename_column rename_table structure_dump table_alias_for table_alias_length table_exists?

### Public Instance methods

add_column(table_name, column_name, type, options = {})

Adds a new column to the named table. See TableDefinition#column for details of the options you can use.

add_index(table_name, column_name, options = {})

Adds a new index to the table. `column_name` can be a single Symbol, or an Array of Symbols.

The index will be named after the table and the first column name, unless you pass `:name` as an option.

When creating an index on multiple columns, the first column is used as a name for the index. For example, when you specify an index on two columns [`:first`, `:last`], the DBMS creates an index for both columns as well as an index for the first column `:first`. Using just the first name for this index makes sense, because you will never have to create a singular index with this name.

##### Examples

###### Creating a simple index

     add_index(:suppliers, :name)

generates

     CREATE INDEX suppliers_name_index ON suppliers(name)

###### Creating a unique index

     add_index(:accounts, [:branch_id, :party_id], :unique => true)

generates

     CREATE UNIQUE INDEX accounts_branch_id_party_id_index ON accounts(branch_id, party_id)

###### Creating a named index

     add_index(:accounts, [:branch_id, :party_id], :unique => true, :name => 'by_branch_party')

generates

     CREATE UNIQUE INDEX by_branch_party ON accounts(branch_id, party_id)

add_order_by_for_association_limiting!(sql, options)

ORDER BY clause for the passed order option. PostgreSQL overrides this due to its stricter standards compliance.

add_timestamps(table_name)

Adds timestamps (created_at and updated_at) columns to the named table.

##### Examples

     add_timestamps(:suppliers)

assume_migrated_upto_version(version)
change_column(table_name, column_name, type, options = {})

Changes the column‘s definition according to the new options. See TableDefinition#column for details of the options you can use.

##### Examples

     change_column(:suppliers, :name, :string, :limit => 80)
     change_column(:accounts, :description, :text)

change_column_default(table_name, column_name, default)

Sets a new default value for a column. If you want to set the default value to `NULL`, you are out of luck. You need to DatabaseStatements#execute the appropriate SQL statement yourself.

##### Examples

     change_column_default(:suppliers, :qualification, 'new')
     change_column_default(:accounts, :authorized, 1)

change_table(table_name) {|Table.new(table_name, self)| ...}

A block for changing columns in `table`.

### Example

     # change_table() yields a Table instance
     change_table(:suppliers) do |t|
       t.column :name, :string, :limit => 60
       # Other column alterations here
     end

##### Examples

###### Add a column

     change_table(:suppliers) do |t|
       t.column :name, :string, :limit => 60
     end

###### Add 2 integer columns

     change_table(:suppliers) do |t|
       t.integer :width, :height, :null => false, :default => 0
     end

###### Add created_at/updated_at columns

     change_table(:suppliers) do |t|
       t.timestamps
     end

###### Add a foreign key column

     change_table(:suppliers) do |t|
       t.references :company
     end

Creates a `company_id(integer)` column

###### Add a polymorphic foreign key column

     change_table(:suppliers) do |t|
       t.belongs_to :company, :polymorphic => true
     end

Creates `company_type(varchar)` and `company_id(integer)` columns

###### Remove a column

     change_table(:suppliers) do |t|
       t.remove :company
     end

###### Remove several columns

     change_table(:suppliers) do |t|
       t.remove :company_id
       t.remove :width, :height
     end

###### Remove an index

     change_table(:suppliers) do |t|
       t.remove_index :company_id
     end

See also Table for details on all of the various column transformation

columns(table_name, name = nil)

Returns an array of Column objects for the table specified by `table_name`. See the concrete implementation for details on the expected parameter values.

create_table(table_name, options = {}) {|table_definition| ...}

Creates a new table with the name `table_name`. `table_name` may either be a String or a Symbol.

There are two ways to work with `create_table`. You can use the block form or the regular form, like this:

### Block form

     # create_table() passes a TableDefinition object to the block.
     # This form will not only create the table, but also columns for the
     # table.
     create_table(:suppliers) do |t|
       t.column :name, :string, :limit => 60
       # Other fields here
     end

### Regular form

     # Creates a table called 'suppliers' with no columns.
     create_table(:suppliers)
     # Add a column to 'suppliers'.
     add_column(:suppliers, :name, :string, {:limit => 60})

The `options` hash can include the following keys:

`:id`
  Whether to automatically add a primary key column. Defaults to true. Join tables for `has_and_belongs_to_many` should set `:id => false`.
`:primary_key`
  The name of the primary key, if one is to be added automatically. Defaults to `id`.
`:options`
  Any extra options you want appended to the table definition.
`:temporary`
  Make a temporary table.
`:force`
  Set to true to drop the table before creating it. Defaults to false.

##### Examples

###### Add a backend specific option to the generated SQL (MySQL)

     create_table(:suppliers, :options => 'ENGINE=InnoDB DEFAULT CHARSET=utf8')

generates:

     CREATE TABLE suppliers (
       id int(11) DEFAULT NULL auto_increment PRIMARY KEY
     ) ENGINE=InnoDB DEFAULT CHARSET=utf8

###### Rename the primary key column

     create_table(:objects, :primary_key => 'guid') do |t|
       t.column :name, :string, :limit => 80
     end

generates:

     CREATE TABLE objects (
       guid int(11) DEFAULT NULL auto_increment PRIMARY KEY,
       name varchar(80)
     )

###### Do not add a primary key column

     create_table(:categories_suppliers, :id => false) do |t|
       t.column :category_id, :integer
       t.column :supplier_id, :integer
     end

generates:

     CREATE TABLE categories_suppliers (
       category_id int,
       supplier_id int
     )

See also TableDefinition#column for details on how to create columns.

distinct(columns, order_by)

SELECT DISTINCT clause for a given set of columns and a given ORDER BY clause. Both PostgreSQL and Oracle overrides this for custom DISTINCT syntax.

      distinct("posts.id", "posts.created_at desc")

drop_table(table_name, options = {})

Drops a table from the database.

initialize_schema_migrations_table()

Should not be called normally, but this operation is non-destructive. The migrations module handles this automatically.

native_database_types()

Returns a Hash of mappings from the abstract data types to the native database types. See TableDefinition#column for details on the recognized abstract data types.

remove_column(table_name, *column_names)

Removes the column(s) from the table definition.

##### Examples

     remove_column(:suppliers, :qualification)
     remove_columns(:suppliers, :qualification, :experience)

remove_columns(table_name, *column_names)

Alias for remove_column

remove_index(table_name, options = {})

Remove the given index from the table.

Remove the suppliers_name_index in the suppliers table.

      remove_index :suppliers, :name

Remove the index named accounts_branch_id_index in the accounts table.

      remove_index :accounts, :column => :branch_id

Remove the index named accounts_branch_id_party_id_index in the accounts table.

      remove_index :accounts, :column => [:branch_id, :party_id]

Remove the index named by_branch_party in the accounts table.

      remove_index :accounts, :name => :by_branch_party

remove_timestamps(table_name)

Removes the timestamp columns (created_at and updated_at) from the table definition.

##### Examples

     remove_timestamps(:suppliers)

rename_column(table_name, column_name, new_column_name)

Renames a column.

##### Example

     rename_column(:suppliers, :description, :name)

rename_table(table_name, new_name)

Renames a table.

##### Example

     rename_table('octopuses', 'octopi')

structure_dump()

Returns a string of `CREATE TABLE` SQL statement(s) for recreating the entire structure of the database.

table_alias_for(table_name)

Truncates a table alias according to the limits of the current adapter.

table_alias_length()

This is the maximum length a table alias can be

table_exists?(table_name)

def tables(name = nil) end

### Protected Instance methods

options_include_default?(options)

[Validate]